# A DOM benchmark

import sys, time

def main():
    global L, doc
    if len( sys.argv ) == 2:
        filename = sys.argv[1]
        modname="xml.dom.ext.reader.Sax"
        funcname="FromXmlFile"
    elif len( sys.argv ) == 4:
        filename = sys.argv[1]
        modname=sys.argv[2]
        funcname=sys.argv[3]
    else:
        print 'Usage: benchmark.py <xml file> [module parsefunction]'
        print 'E.g. benchmark.py hamlet.xml minidom parse'
        print 'E.g. benchmark.py hamlet.xml xml.dom '
        sys.exit()

    mod=__import__( modname, globals(), locals(), [funcname] )
    func=getattr( mod, funcname )
    
    file = open(filename, 'r')
    size = len(file.read())
    file.close()

    print 'File %s is %iK in size' % (filename, size / 1024)
    
    start_time = time.time()
    doc = func( filename ) 
    end_time = time.time()
    print 'Building DOM tree:', end_time - start_time, 'sec'

    # Convert DOM tree back to XML
    start_time = time.time()
    xml = doc.toxml()
    end_time = time.time()
    print 'Serializing back to XML:', end_time - start_time, 'sec'

    # Time a complete getElementsByTagName()
    start_time = time.time()
    L = doc.getElementsByTagName("*")
    end_time = time.time()
    print 'getElementsByTagName("*")=%s: %s sec'%( 
                                        len( L ) , end_time - start_time )
    print L[0].nodeName
    
if __name__ == '__main__': main()
