import pulldom
import profile
import time
import sys

filename = "hamlet.xml"

def basic_test():
    events=pulldom.parse( filename, bufsize=bufsize )
    token="parrot"
    while token:
        token=events.getEvent( )
        if token:
            (token_type, node)=token
            assert hasattr( node, "attributes" )
            assert hasattr( node, "nodeValue" )
            assert hasattr( node, "nodeName" )
            assert hasattr( node, "childNodes" )
            assert hasattr( node, "nodeType" )
            assert hasattr( node, "parentNode" )
            assert node.parentNode or node.nodeType==node.DOCUMENT_NODE
            assert (not node.attributes or node.nodeType==node.ELEMENT_NODE )

            assert node.nodeValue==node._get_nodeValue()
            if node.attributes:
                assert node.attributes==node._get_attributes()

            assert token_type in ("START_ELEMENT", "END_ELEMENT", 
                            "COMMENT", "START_DOCUMENT", "END_DOCUMENT",
                             "PROCESSING_INSTRUCTION", 
                             "IGNORABLE_WHITESPACE", "CHARACTERS")
        try: # test __getattr__
            print node.junk
            raise AssertionError, "__getattr__ is broken"
        except AttributeError:
            pass

def iterator_test():
    for (token_type, node) in pulldom.parse( filename, bufsize=bufsize ):
        pass # print token_type, node

def profile_test( func ):
    profile.run(func, 'fooprof')

    import pstats
    p = pstats.Stats('fooprof')

    print p.sort_stats('cumulative').print_stats(15)
    print p.sort_stats('time').print_stats(15)

#print "ev", events[0]

#iterator_test()

#events=pulldom.parse( filename, bufsize=bufsize )
#out=open( "junk1.out", "w" )
#for (token,node) in events:
#        out.write( ""+repr( node ))

def timeit( func ):
    start=time.time()
    func()
    end=time.time()
    print func.__name__, end-start

a=0
def noop( event, node ): 
    global a
    a=a+1
    return a

def spinloop():
    for (event,node) in pulldom.parse( filename, bufsize=bufsize ): 
        noop( event,node)


root=None

def buildDOM():
    global root
    import minidom
    root=minidom.parse( filename, bufsize=bufsize )
    print root.documentElement

def deleteDOM( ):
        global root
        root.unlink()
        del root

def writeDOM( ):
        root.writexml( open( "test1.out", "w" ) )

print "Default buffer size"
bufsize=pulldom.default_bufsize
timeit( spinloop )
timeit( basic_test )
timeit( buildDOM )
keep=root.toxml()
timeit( writeDOM )
timeit( deleteDOM )

print
print "Very, very small buffer"
bufsize=10
timeit( spinloop )
timeit( basic_test )
timeit( buildDOM )
assert keep==root.toxml()
timeit( writeDOM )
timeit( deleteDOM )
